-- Author      : Weeperman
-- Create Date : 07/01/2011 

local critterTrackId = nil
local critterTrackIdCKS = 5144 -- Critter Kill Squad
local critterTrackIdCG = 5263 -- Crittergeddon
local defaultReportFrequency = 10
local defaultLocalReportFrequency = 1
local Critterz_MainFrame          
local knownCritterzHex = nil
local LocalReportFrequency = 1
local ReportFrequency = nil
local PingGuild = nil                    

                    
function Critterz_OnLoad()

    Critterz_MainFrame = CreateFrame("Frame", "CritterzFrame",UIParent);
    Critterz_MainFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
    Critterz_MainFrame:RegisterEvent("VARIABLES_LOADED");    
    Critterz_MainFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
    Critterz_MainFrame:SetScript("OnEvent", Critterz_OnEvent);   

end

function AddCritterzOnDemand()
    local critterListHex = {
        "0CE4", -- Adder
        "C273", -- Alpine Chipmunk
        "BF27", -- Alpine Hare
        "C2C2", -- Amethyst Shale Hatchling
        "9C62", -- Anxious Doe
        "739A", -- Angry Turkey
        "7290", -- Arctic Hare
        "C52E", -- Ash Lizard
        "C158", -- Ash Spiderling
        "C1A0", -- Ash Viper
        "8577", -- Ashenvale Oak
        "D403", -- Ashtongue Adder
        "9C8A", -- Atiu
        "9CFC", -- Attuned Frog
        "9C8B", -- Avarua
        "895A", -- Azshara Sapling
        "8019", -- Baby Bunny
        "7EC2", -- Badluck
        "6B45", -- Bambina
        "BDF6", -- Baradin Fox Kit
        "50F5", -- Bat
        "A076", -- Bebe
        "9E5B", -- Beetle
        "3C73", -- Beetle
        "29DC", -- Belfry Bat
        "65F2", -- Bess
        "0EFB", -- Biletoad
        "5920", -- Black Cat
        "083E", -- Black Rat
        "9557", -- Blood Parasite
        "9558", -- Blood Spider
        "6D71", -- Bloodworm
        "644D", -- Borean Frog
        "7BC5", -- Borean Marmot
        "433D", -- Broom
        "57D0", -- Brown Marmot
        "71CE", -- Brown Rabbit
        "AF49", -- Buzzard
        "166D", -- Caged Rabbit
        "166F", -- Caged Sheep
        "166B", -- Caged Squirrel
        "166E", -- Caged Toad
        "4FAC", -- Captured Critter
        "C535", -- Carrion Rat
        "18E0", -- Cat
        "74B1", -- Cat Specimen
        "8E6B", -- Chance
        "AD32", -- Chicken
        "026D", -- Chicken
        "026C", -- Chicken
        "6E01", -- Chicken Escapee
        "D1C1", -- Cinderling (new 4.2)
        "D404", -- Cinderslither Snake (new 4.2)
        "3ADA", -- Cleo
        "679D", -- Cockroach
        "B17F", -- Cockroach
        "C23C", -- Coral Snake
        "341A", -- Core Rat
        "C3DD", -- Corpse-Fed Rat
        "845C", -- Corrupted Duskrat
        "593A", -- Corvax
        "098A", -- Cow
        "8E9B", -- Crab
        "1AAB", -- Crab
        "BEC1", -- Crab Hatchling
        "7E05", -- Crystal Spider
        "C308", -- Crimson Moth
        "C309", -- Crimson Shale Hatchling
        "C26B", -- Crystal Beetle
        "821C", -- Crystalsong Oak
        "300B", -- Cured Deer
        "3009", -- Cured Gazelle
        "8602", -- Darkshore Wisp
        "758E", -- Dalaran Sewer Rat
        "758F", -- Dalaran Sewer Turtle
        "B5AD", -- Darkwood Hatchling
        "C25F", -- Death's Head Cockroach
        "C26A", -- Deepholm Cockroach
        "C2AB", -- Desert Spider
        "32D8", -- Deeprun Rat
        "0373", -- Deer
        "5ECE", -- Devouring Maggot
        "0D74", -- Dig Rat
        "7159", -- Disgruntled Bug
        "2956", -- Dog
        "651E", -- Doomsday Rat
        "41DB", -- Dragonhawk Hatchling
        "C24F", -- Dung Beetle
        "C21A", -- Dusk Spiderling
        "BEC9", -- Eel Larva
        "2303", -- Effsee
        "C240", -- Elfin Rabbit
        "C23D", -- Emerald Boa
        "C2C1", -- Emerald Shale Hatchling
        "936A", -- Enervated Adder
        "32D9", -- Enthralled Deeprun Rat
        "4CD1", -- Ewe
        "3A2C", -- Fang
        "037A", -- Fawn
        "C274", -- Fire-Proof Roach
        "25E3", -- Fire Beetle
        "6EF7", -- Fjord Penguin
        "5E6E", -- Fjord Rat
        "60AA", -- Fjord Turkey
        "BE1F", -- Flamefly
        "9396", -- Flesh-eating Insect
        "6B42", -- Flora
        "0548", -- Fluffy
        "C2B2", -- Forest Moth
        "C537", -- Forest Spiderling
        "AD8A", -- Frightened Chicken
        "3409", -- Frog
        "8EEF", -- Frog
        "872E", -- Frost Sphere
        "95E2", -- Frozen Insect
        "9555", -- Frozen Insect
        "9C89", -- Funafuti
        "C2B7", -- Fungal Moth
        "61E2", -- Fuzz
        "1046", -- Gazelle
        "5DAB", -- Giant Marsh Frog
        "BEA0", -- Giant Sea Roach
        "C454", -- Gilnean Crow
        "7EF2", -- Glacier Penguin
        "6ED4", -- Glinting Bug
        "B857", -- Gobbles
        "B897", -- Gobbles
        "7E02", -- Gold Beetle
        "3E33", -- Golden Hare
        "C34F", -- Grasslands Cottontail
        "9401", -- Graveyard Rat
        "7C91", -- Grizzly Squirrel
        "C4F3", -- Grotto Vole
        "C24E", -- Hairy Armadillo
        "C247", -- Harlequin Frog
        "173F", -- Hare
        "ABC5", -- Hazzranache
        "BD4A", -- Healthy Squirrel
        "BE92", -- Highlands Clucker
        "BE31", -- Highlands Mouse
        "BE30", -- Highlands Skunk
        "C244", -- Horned Lizard
        "0181", -- Horse
        "19FD", -- Huge Toad
        "759E", -- Hungry Penguin
        "7227", -- Image of Mr. Bigglesworth
        "2A1C", -- Infected Deer
        "2A1B", -- Infected Squirrel
        "9C40", -- Injured Fawn
        "9C3F", -- Injured Fawn
        "BB69", -- Inky Ooze
        "BF3C", -- Irradiated Roach
        "8F71", -- Island Turtle
        "ABC7", -- Jazzranache
        "3AA2", -- Jungle Toad
        "BEED", -- Juvenile Coral Crab
        "D405", -- Kindleworm
        "3AD9", -- Lady
        "81C8", -- Lake Frog
        "81BB", -- Lake Frog
        "3EC4", -- Larva
        "25E4", -- Lava Crab
        "C2A8", -- Leopard Scorpion
        "6DC4", -- Lemming
        "6A8C", -- Let Them Not Rise! Rat
        "6AD8", -- Levine Family Termite
        "B13B", -- Lil' Sooty
        "C52F", -- Lizard Hatchling
        "C53A", -- Locust
        "BF4C", -- Long-tailed Mole
        "C53B", -- Mac Frog
        "3E9E", -- Maggot
        "D402", -- Magmaspray Beetle (new 4.2)
        "56AD", -- Marmot
        "9C8D", -- Mata
        "67A3", -- Mesmerized Frog
        "1359", -- Moccasin
        "7ED2", -- Monstrous Underbelly Rat
        "6B44", -- Mother of Bambina
        "8221", -- Mottled Doe
        "C34C", -- Mountain Cottontail
        "7C92", -- Mountain Skunk
        "187F", -- Mouse
        "4266", -- Mr. Bigglesworth
        "BE2F", -- Mule Deer
        "AF87", -- Mutant Bush Chicken
        "AF86", -- Mutant Bush Chicken
        "305F", -- Nibbles
        "1C28", -- Noarm
        "800D", -- Noblegarden Rabbit
        "C540", -- Oasis Moth
        "0246", -- Old Blanchy
        "9C3D", -- Panicked Bunny
        "2580", -- Parrot
        "1EDA", -- Pirate treasure trigger mob
        "28DD", -- Plagued Insect
        "9554", -- Plagued Insect
        "2928", -- Plagued Maggot
        "28C9", -- Plagued Rat
        "6CC5", -- Plagued Roach
        "6CCF", -- Plagued Vermin
        "2F58", -- Plagueland Termite
        "405F", -- Polymorph Clone
        "0A3C", -- Prairie Dog
        "BD99", -- Prison Rat
        "9404", -- Putrescent Maggot
        "02D1", -- Rabbit
        "C26C", -- Rabbot
        "C26E", -- Rabid Nut Varmint 5000
        "4385", -- Ragnarose
        "6B2E", -- Rainbow Trout
        "0832", -- Ram
        "0FEB", -- Rat
        "C209", -- Rat Snake
        "BE2E", -- Rattlesnake
        "A2B3", -- Raven
        "ABC6", -- Razzranache
        "4FAE", -- Reanimated Critter
        "6C96", -- Reincarnated Skytalon
        "C272", -- Red-Tailed Chipmunk
        "C34B", -- Redridge Rat
        "22B1", -- Riding Ram
        "BEC6", -- Rift Elver
        "9C8C", -- Rima
        "0FEC", -- Roach
        "C26D", -- Robo-Chick
        "C531", -- Rock Viper
        "BED0", -- Rockchewer Whelk
        "8E55", -- Rocketway Rat
        "593B", -- Rook
        "85E7", -- Ruby Hare
        "4C1A", -- Sagan
        "AEA6", -- Sand Kitten
        "BA42", -- Sassy Cat
        "2E00", -- Salome
        "6787", -- Scalawag Frog
        "C252", -- Scarab Hatchling
        "1801", -- School of Fish
        "B13D", -- Scoot
        "3C74", -- Scorpion
        "9CF0", -- Sen'jin Frog
        "5A2F", -- Sewer Crocolisk
        "7ED6", -- Sewer Frog
        "BEA2", -- Sea Cucumber
        "AF50", -- Sea Gull
        "5A2E", -- Sewer Rat
        "8F6A", -- Sheep
        "B85A", -- Sheep
        "078D", -- Sheep
        "3819", -- Shen'dralar Wisp
        "6DBD", -- Sholazar Tickbird
        "300A", -- Sickly Deer
        "3008", -- Sickly Gazelle
        "C23F", -- Sidewinder
        "A9EC", -- Silithian Hatchling
        "C2B4", -- Silky Moth
        "5722", -- Skittering Cavern Crawler
        "AF6C", -- Skitterweb Invisible Stalker
        "443B", -- Skunk
        "B13A", -- Smokey
        "BAB2", -- Snake
        "0B62", -- Snake
        "4AD2", -- Soot
        "6ED3", -- Sparkling Hare
        "A29A", -- Spaz
        "ABC8", -- Spazzranache
        "4FBB", -- Spectral Bovine
        "B3C0", -- Spectral Critter
        "3A21", -- Spider
        "3AE0", -- Spike
        "C2B0", -- Spiky Lizard
        "C2AD", -- Spiny Lizard
        "C246", -- Spotted Bell Frog
        "0584", -- Squirrel
        "644F", -- Steam Frog
        "C2AC", -- Stinkbug
        "8965", -- Stonetalon Wisp
        "C184", -- Stormwind Rat
        "C25E", -- Stowaway Rat
        "C2A9", -- Stripe-Tailed Scorpion
        "C350", -- Swamp Moth
        "29BD", -- Swine
        "2721", -- Tainted Cockroach
        "C353", -- Tainted Moth
        "2720", -- Tainted Rat
        "BD49", -- Tainted Squirrel
        "A0B7", -- Tame Crag Boar
        "BEE9", -- Tekton
        "9C3E", -- Terrified Squirrel
        "469E", -- The Evil Rabbit
        "6B43", -- Thudder
        "ACAD", -- Tiny Ooze
        "058C", -- Toad
        "C2C3", -- Topaz Shale Hatchling
        "C23A", -- Tree Python
        "6F18", -- Tundra Penguin
        "5CF9", -- Turkey
        "C2C5", -- Twilight Beetle
        "BE34", -- Twilight Spider
        "7EAC", -- Underbelly Rat
        "C32D", -- Undercity Rat
        "3ADF", -- Underfoot
        "9403", -- Underground Spider
        "6B5D", -- Vengeful Bambina
        "8832", -- Webbed Rabbit
        "BA33", -- Wharf Rat
        "94DF", -- Wild Clucker
        "A9FE", -- Wild Rat
        "BF13", -- Wildhammer Gryphon Chick
        "C7B6", -- Wildhammer Gryphon Chick
        "0E61", -- Wisp
        "BDEF", -- Wisp
        "BDF0", -- Wisp
        "BE2B", -- Yellow-Bellied Marmot
        "48DB", -- Young Blanchy
        "75BC", -- Zena
        "6E2A", -- Zul'Drak Rat",
    }
    
    knownCritterzHex = critterListHex
end

-- correct string.sub for all language clients
-- http://wowprogramming.com/snippets/UTF-8_aware_stringsub_7

-- UTF-8 Reference:
-- 0xxxxxxx - 1 byte UTF-8 codepoint (ASCII character)
-- 110yyyxx - First byte of a 2 byte UTF-8 codepoint
-- 1110yyyy - First byte of a 3 byte UTF-8 codepoint
-- 11110zzz - First byte of a 4 byte UTF-8 codepoint
-- 10xxxxxx - Inner byte of a multi-byte UTF-8 codepoint
 
function chsize(char)
    if not char then
        return 0
    elseif char > 240 then
        return 4
    elseif char > 225 then
        return 3
    elseif char > 192 then
        return 2
    else
        return 1
    end
end

-- This function can return a substring of a UTF-8 string, properly handling
-- UTF-8 codepoints.  Rather than taking a start index and optionally an end
-- index, it takes the string, the starting character, and the number of
-- characters to select from the string.
function utf8sub(str, startChar, numChars)
  local startIndex = 1
  while startChar > 1 do
      local char = string.byte(str, startIndex)
      startIndex = startIndex + chsize(char)
      startChar = startChar - 1
  end

  local currentIndex = startIndex

  while numChars > 0 and currentIndex <= #str do
    local char = string.byte(str, currentIndex)
    currentIndex = currentIndex + chsize(char)
    numChars = numChars -1
  end
  return str:sub(startIndex, currentIndex - 1)
end

function CompletedAchievement(achievementID)

    ToggleAchievement = not IsTrackedAchievement(achievementID)
    
    -- toggle the tracked achievement to reset the values 
    if (ToggleAchievement) then
        AddTrackedAchievement(achievementID);
    end
    
    local _ ,  completed = GetAchievementCriteriaInfo(achievementID,GetAchievementNumCriteria(achievementID))
    
    if (ToggleAchievement) then
        RemoveTrackedAchievement(achievementID);
    end
    
    return completed
end



function DetermineTrackableId()
    if (critterTrackId == nil) then
        local completedCKS = CompletedAchievement(critterTrackIdCKS)
        
        if (completedCKS == true) then
        
            local completedCG = CompletedAchievement(critterTrackIdCG)
            
            if (completedCG == true) then
                critterTrackId = 0
            else
                critterTrackId = citterTrackIdCG
            end
        else
            critterTrackId = critterTrackIdCKS
        end        
    end
end

function Critterz_OnEvent(self, event, ...)

    local  timestamp, type, hideCaster, sourceGUID, Playername, sourceFlags, _, destGUID, destCritter, destFlags = select(1, ...)         
     
    if (event=="COMBAT_LOG_EVENT_UNFILTERED") then                      
        if (type == "PARTY_KILL") then         
            if (Playername == UnitName("player") and destGUID ~= nil) then
                DetermineTrackableId()       
                if (critterTrackId ~= 0) then           
                
                    -- ondemand load
                    if (knownCritterzHex == nil) then
                        AddCritterzOnDemand()
                    end
                                   
                    -- only need the 4 char code for the critter id
                    local lookupCritterHex = utf8sub(destGUID,7,4)      
                    if (tContains( knownCritterzHex, lookupCritterHex )) then                    
                        _ , _, _, quantity, reqQuantity, _, _, _, _, _=  GetAchievementCriteriaInfo(critterTrackId, GetAchievementNumCriteria(critterTrackId))
                        -- reset and get the required id
                        if (quantity == 0) then
                            critterTrackId = nil
                            DetermineTrackableId()
                            _ , _, _, quantity, reqQuantity, _, _, _, _, _=  GetAchievementCriteriaInfo(critterTrackId, GetAchievementNumCriteria(critterTrackId))
                        end                    
                        
                        -- another critter killed
                        IndivCritzKilled = IndivCritzKilled + 1
                                            
                        if (quantity > 0 ) then
                            local LeftToKill = reqQuantity-quantity;
                            if LeftToKill > 0 then    
                                local message = string.format("A %s died in %s, only %d critters to go. (I've killed at least %d of them)",destCritter,GetRealZoneText(),LeftToKill,IndivCritzKilled);
                                         
                                if ((IndivCritzKilled % ReportFrequency == 0) and (PingGuild == true)) then
                                    -- only update the guild when required
                                    SendChatMessage(message ,"GUILD");
                                else 
--                                    if (IndivCritzKilled % LocalReportFrequency == 0) then
                                        -- otherwise keep it to your self
                                        DEFAULT_CHAT_FRAME:AddMessage(message);
--                                    end
                                end 
                            else
                                DEFAULT_CHAT_FRAME:AddMessage("Another Critter died, no more please - make the madness stop.");
                            end
                        end
                    end
                end                                        
            end        
        end
    elseif(event == "VARIABLES_LOADED") then
        
        local version =  tostring(GetAddOnMetadata("Critterz","Version"))
        
        if ReportFrequency == nil then
            ReportFrequency = defaultReportFrequency;
        end
        
        if PingGuild == nil then
            PingGuild = true -- suitable default
        end        
        
        if IndivCritzKilled == nil then
            IndivCritzKilled = 0 -- suitable default
        end
        
        if LocalReportFrequency == nil then
            LocalReportFrequency = 1 --suitable default
        end
        
        
        DetermineTrackableId()
            
        if (critterTrackId == 0) then
            DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffffffCritterz|cffff9900 %s|cffffffff loaded. No more please ... it hurts ...", version))  
        else
                            
            _ , _, _, quantity, reqQuantity, _, _, _, _, _=  GetAchievementCriteriaInfo(critterTrackId, GetAchievementNumCriteria(critterTrackId)); 
            _, Name, _, _, _, _, _, _, _, _, _ = GetAchievementInfo(critterTrackId)
            local LeftToKill = reqQuantity-quantity;

            
            if LeftToKill > 0 then
                DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffffffCritterz|cffff9900 %s|cffffffff loaded. We still need %d for %s", version, LeftToKill,Name))  
            else
                DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffffffCritterz|cffff9900 %s|cffffffff loaded. Your guild is the '%s'", version, Name))  
            end 
        end
       
        -- configure config panel
        CritterzConfig = {}
        CritterzConfig.panel = CreateFrame( "Frame", "Critterz_Config", UIParent );
        GuildPingBox = CreateFrame("CheckButton","GuildPing", CritterzConfig.panel,"UICheckButtonTemplate")
        GuildPingBox:SetPoint("TOPLEFT",CritterzConfig.panel,"TOPLEFT",25,-60)
        GuildPingBox:SetChecked(PingGuild)

        GuildPingBoxLabel = GuildPingBox:CreateFontString("GuildLab") 
        GuildPingBoxLabel:SetPoint("CENTER",GuildPingBox,"RIGHT",0,-10)
        GuildPingBoxLabel:SetFontObject(GameFontNormal)
        GuildPingBoxLabel:SetText("Ping Guild")   


        PingFrqSlider = CreateFrame("Slider", "PingFrequency", CritterzConfig.panel, "OptionsSliderTemplate")
        PingFrqSlider:SetOrientation('HORIZONTAL')
        PingFrqSlider:SetPoint("TOPLEFT",GuildPingBox,"TOPRIGHT",40,00)
        PingFrqSlider:SetMinMaxValues(1,100);
        PingFrqSlider:SetValueStep(5)

         getglobal(PingFrqSlider:GetName() .. 'Low'):SetText('1');
         getglobal(PingFrqSlider:GetName() .. 'High'):SetText('100');
         getglobal(PingFrqSlider:GetName() .. 'Text'):SetText('Ping Guild Frequency');
        PingFrqSlider:SetValue(ReportFrequency)

--        LocalPingFrqSlider = CreateFrame("Slider", "LocalReportPingFrequency", CritterzConfig.panel, "OptionsSliderTemplate")
--        LocalPingFrqSlider:SetOrientation('HORIZONTAL')
--         LocalPingFrqSlider:SetPoint("TOPLEFT",PingFrqSlider,"BOTTOMLEFT",0,-40)
--        LocalPingFrqSlider:SetMinMaxValues(1,10);
--        LocalPingFrqSlider:SetValueStep(1)

--         getglobal(LocalPingFrqSlider:GetName() .. 'Low'):SetText('1');
--         getglobal(LocalPingFrqSlider:GetName() .. 'High'):SetText('10');
--         getglobal(LocalPingFrqSlider:GetName() .. 'Text'):SetText('Local Ping Frequency');
--        LocalPingFrqSlider:SetValue(LocalReportFrequency)
        
         
         -- Register in the Interface Addon Options GUI
         -- Set the name for the Category for the Options Panel
         CritterzConfig.panel.name = "Critterz";
         
        CritterzConfig.panel.okay  = function (self) 
            Critterz_Config_Okay(); 
        end;

        CritterzConfig.panel.default = function (self)  
            Critterz_Config_Default();  
        end;
         
         -- Add the panel to the Interface Options
        InterfaceOptions_AddCategory(CritterzConfig.panel);               
    end
end

function Critterz_Config_Okay()
    ReportFrequency = PingFrqSlider:GetValue()
--    LocalReportFrequency = LocalPingFrqSlider:GetValue()
    if (GuildPingBox:GetChecked() == 1) then
        PingGuild = true
    else
        PingGuild = false
    end
end



function Critterz_Config_Default()
    ReportFrequency = defaultReportFrequency
    PingGuild = true
    LocalReportFrequency = 1
end

-- now start it up
Critterz_OnLoad();
